% CoMa2 - SS11
% Aufg.3.3

% Test von neville, horner und aitkenneville; wir wollen vor allem den
% Aufwand verifizieren

clear all

% an dieser Stelle soll das Interpolationspolynom ausgewertet werden
z = pi - 3;
% hier tragen wir die Anzahlen der Punktoperationen ein
aufwand1 = zeros(1,100);    aufwand2 = zeros(1,100);

for n=1:100
    % nehmen wir einfach quidistante Sttzstellen auf [-1,1]
    x = -1:2/n:1;
    % neville und horner; f = exp
    [d,a1] = neville(x,exp(x));
    [p,a2] = horner(x,d,z);
    aufwand1(n) = a1 + a2;
    % aitkenneville
    [p,b] = aitkenneville(x,exp(x),z);
    aufwand2(n) = b;
end

% Plots: Anzahl Sttzstellen gegen Anzahl Punktoperationen
figure(1);
plot(1:100,aufwand1);
title('Aufwand von Neville und Horner');
xlabel('Anzahl Sttzstellen');
ylabel('Aufwand (Anzahl Punktoperationen)');

figure(2);
plot(1:100,aufwand2);
title('Aufwand von Aitken-Neville');
xlabel('Anzahl Sttzstellen');
ylabel('Aufwand (Anzahl Punktoperationen)');