% CoMa2 - SS11
% Aufg.3.3 1.(a)
function [d,anzpkt] = neville(x,f)
% Programm berechnet dividierte Differenzen f[x_1,...,x_k] , k=1,...,n und gibt sie
% zurck; 
% Input: Vektor x=(x_1,...,x_n) mit Sttzstellen und Vektor f mit
% Funktionswerten f(x_1),...,f(x_n)
% Outputs: Vektor d mit div.Diff.; d(n) = f[x_1,...,x_n]
% anzpkt ist die Anzahl der bentigten Punktoperationen

% Vorgehen nach Algorithmus 1.6 unter Benutzung von Satz 1.5

anzpkt = 0;
n = length(x);  % x und f sollten gleich lange Vektoren sein
% Baue Neville-Schema mit Hilfe einer Matrix auf
A = zeros(n,n);
A(:,1) = f;     % f[x_i]  i=1,...,n
for i = 2:n
    for k = i:n
        A(k,i) = (A(k,i-1) - A(k-1,i-1)) / (x(k) - x(k-i+1));   
        % [f_i,...,f_k] i<k
        anzpkt = anzpkt + 1;    % pro (inneren) Schleifendurchlauf 1 
        % Division
    end
end
% Ergebnis:
d = diag(A);